#import "MyView.h"
#import "TDUndoManager.h"

@implementation MyView

- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil)
	{
		size = 50;
		useTDUndoManager = NO;
	}
	return self;
}

- (void)drawRect:(NSRect)rect
{
	NSEraseRect(rect);
	
	NSRect r = NSMakeRect(130-size/2,130-size/2,size,size);
	
	NSRectFill(r);
}

- (IBAction)change:(id)sender
{
	[self setSize: [sender floatValue]];
		
	if(sender != slider)
	{
		[slider setFloatValue:size];
	}
}

- (void)setSize:(float)newSize
{
	if(newSize != size)
	{
		if(useTDUndoManager)
			[(MyView*)[(TDUndoManager*)[document undoManager] prepareWithSkippableInvocationTarget:self] setSize:size];
		else
			[(MyView*)[[document undoManager] prepareWithInvocationTarget:self] setSize:size];

		size = newSize;
		
		[self setNeedsDisplay:YES];
		[self updateInfo];
	}
}

// a hacked method to show the undo manager stack size
- (void)updateInfo
{
	NSString *infoString;
		
	id undoStack = (id)[[document undoManager] _undoStack];
	
	int c = [undoStack count];
	
	//one very mad way of doing this
	NSString *desc = [undoStack description];
	NSArray *lines = [desc componentsSeparatedByString:@"\n"];
	
	int count = [lines count];
	
	infoString = [NSString stringWithFormat:@"Undo stack size:%d (%d)", count, c];
		
	[info setStringValue:infoString];
}

@end
