//
//  TDUndoManager.m
//  TDUndoM
//
//  Created by William Thimbleby on 03/09/2005.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "TDUndoManager.h"

@implementation TDUndoManager

- (id)init
{
	[super init];

	lastSelector = 0;

	return self;
}

- (id) prepareWithSkippableInvocationTarget:(id)target;
{
	skipTarget = target;
	skipping = YES;
	
	return [super prepareWithInvocationTarget:target];
}

- (void) registerSkippableUndoWithTarget:(id)target selector:(SEL)sel object:(id)parameter;
{
	skipTarget = target;
	skipping = YES;
	
	[super registerUndoWithTarget:(id)target selector:(SEL)sel object:(id)parameter];
}

- (void)beginUndoGrouping
{
	skipping = NO;
	lastSelector = 0;
	[super beginUndoGrouping];
}

- (void)endUndoGrouping
{
	skipping = NO;
	lastSelector = 0;
	[super endUndoGrouping];
}

- (void) forwardInvocation:(id)invocation;
{
	if(skipping && lastSelector != 0)
	{
		skipping = NO;
		
		//if the target and selector are the same return
		if(lastTarget == skipTarget && lastSelector == [invocation selector])
		{
			return;
		}
	}
	
	lastTarget = skipTarget;
	lastSelector = [invocation selector];
	[super forwardInvocation: invocation];
}

@end
